#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "apptout.h"

PCSVD AddChainForTime(PCSVD start_csvd, PCSVD curr_csvd)
{
  PCSVD work_csvd, prev_csvd;
  PNRA  curr_nra, work_nra;
  short iStartTimeWork;
  short iStartTimeCurr;
  
  curr_nra = curr_csvd->pnra;
  
  if (start_csvd == NULL){
    return(curr_csvd);
  }
  
  work_csvd = start_csvd;
  prev_csvd = start_csvd;
  for (;work_csvd;work_csvd = work_csvd->pnext_csvd){
    work_nra = work_csvd->pnra;

    iStartTimeWork=work_nra->cStartTimePri2*256 + work_nra->cStartTimePri1;
    iStartTimeCurr=curr_nra->cStartTimePri2*256 + curr_nra->cStartTimePri1;
    if (iStartTimeWork > iStartTimeCurr){
      break;
    }
    prev_csvd = work_csvd;
  }

  if(work_csvd == NULL && prev_csvd != NULL){
    prev_csvd->pnext_csvd = curr_csvd;
  }else{
    if(prev_csvd == work_csvd)
      start_csvd = curr_csvd;
    else
      prev_csvd->pnext_csvd = curr_csvd;
    curr_csvd->pnext_csvd = work_csvd;
  }

  return(start_csvd);
}
