#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "apptout.h"

void AddSeekInfo(PSINF *pSeekInfo, PRHDR prhdr, long lSeek)
{
  PSINF work, prev, curr;

  for (work=prev=pSeekInfo[prhdr->cType];work;work=work->pnext_sinf){
    if (work->iRecordNum > prhdr->iRecord) break;
    prev = work;
  }

  if ((curr=(PSINF)malloc(sizeof(SINF))) == NULL){
    fprintf(stderr, "Not enough memory in AddSeekInfo.\n");
    exit(1);
  }

  curr->lSeekPt = lSeek;
  curr->iSize = prhdr->iLength;
  curr->iRecordNum = prhdr->iRecord;
  curr->pnext_sinf = NULL;

  if(work == NULL && prev == NULL){
    pSeekInfo[prhdr->cType] = curr;
  }else if(work != NULL && prev == NULL){
    work->pnext_sinf = curr;
  }else if(work == NULL && prev != NULL){
    prev->pnext_sinf = curr;
  }else{
    if(prev == work)
      pSeekInfo[prhdr->cType] = curr;
    else
      prev->pnext_sinf = curr;
    curr->pnext_sinf = work;
  }
}
