#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "apptout.h"

extern short iAppt;
extern short iEvent;
extern short iToDo;
extern long  lCutStart;
extern long  lCutEnd;


void OutputData(PSCSV start_scsv)
{
  char  szDate[9];
  PCSVD	start_csvd, other_csvd, work_csvd, work2_csvd;
  PNRA  work_nra, work2_nra;
  long  lDate;

  start_csvd = start_scsv->start_csvd;
  other_csvd = start_scsv->other_csvd;

  for(work_csvd=other_csvd;work_csvd;work_csvd=work_csvd->pnext_csvd){
    work_nra = work_csvd->pnra;

    sprintf(szDate, "%4d%02d%02d",
    	work_nra->cYear+1900, work_nra->cMonth+1, work_nra->cDay+1);
    lDate = (long)atof(szDate);
    if (lDate<lCutStart || lCutEnd<lDate) continue;

    if (iAppt && work_csvd->cKind == 128){
      if (iAppt == 1)
		WriteCSV(work_csvd);
      if (iAppt == 2 && work_nra->cRepeatType == 1)
		WriteCSV(work_csvd);
	  if (iAppt == 3 && work_nra->cRepeatType > 1)
		WriteCSV(work_csvd);
	}else if (iEvent && work_csvd->cKind == 32){
	  if (iEvent == 1)
		WriteCSV(work_csvd);
      if (iEvent == 2 && work_nra->cRepeatType == 1)
		WriteCSV(work_csvd);
	  if (iEvent == 3 && work_nra->cRepeatType > 1)
		WriteCSV(work_csvd);
	}else if (iToDo && work_csvd->cKind ==16){
	  if (iToDo == 1 || iToDo == 4)
		WriteCSV(work_csvd);
      if (iToDo == 2 && work_nra->cRepeatType == 1)
		WriteCSV(work_csvd);
	  if (iToDo == 3 && work_nra->cRepeatType > 1)
		WriteCSV(work_csvd);
	}
  }

  for(work_csvd=start_csvd;work_csvd;work_csvd=work_csvd->pnext_csvd){
    work_nra = work_csvd->pnra;

    sprintf(szDate, "%4d%02d%02d",
    	work_nra->cYear+1900, work_nra->cMonth+1, work_nra->cDay+1);
    lDate = (long)atof(szDate);
    if (lDate<lCutStart || lCutEnd<lDate) continue;

    if (iAppt && work_csvd->cKind == 128){
      if (iAppt == 1)
		WriteCSV(work_csvd);
      if (iAppt == 2 && work_nra->cRepeatType == 1)
		WriteCSV(work_csvd);
	  if (iAppt == 3 && work_nra->cRepeatType > 1)
		WriteCSV(work_csvd);
	}else if (iEvent && work_csvd->cKind == 32){
	  if (iEvent == 1)
		WriteCSV(work_csvd);
      if (iEvent == 2 && work_nra->cRepeatType == 1)
		WriteCSV(work_csvd);
	  if (iEvent == 3 && work_nra->cRepeatType > 1)
		WriteCSV(work_csvd);
	}else if (iToDo && work_csvd->cKind ==16){
	  if (iToDo == 1 || iToDo == 4)
		WriteCSV(work_csvd);
      if (iToDo == 2 && work_nra->cRepeatType == 1)
		WriteCSV(work_csvd);
	  if (iToDo == 3 && work_nra->cRepeatType > 1)
		WriteCSV(work_csvd);
	}

    other_csvd = work_csvd->pdown_csvd;

    for(work2_csvd=other_csvd;work2_csvd;work2_csvd=work2_csvd->pnext_csvd){
	  work2_nra = work2_csvd->pnra;
	  if (iAppt && work2_csvd->cKind == 128){
	    if (iAppt == 1)
		  WriteCSV(work2_csvd);
		if (iAppt == 2 && work2_nra->cRepeatType == 1)
		  WriteCSV(work2_csvd);
		if (iAppt == 3 && work2_nra->cRepeatType > 1)
		  WriteCSV(work2_csvd);
	  }else if (iEvent && work2_csvd->cKind == 32){
	    if (iEvent == 1)
		  WriteCSV(work2_csvd);
		if (iEvent == 2 && work2_nra->cRepeatType == 1)
		  WriteCSV(work2_csvd);
		if (iEvent == 3 && work2_nra->cRepeatType > 1)
		  WriteCSV(work2_csvd);
	  }else if (iToDo && work2_csvd->cKind ==16){
	    if (iToDo == 1 || iToDo == 4)
		  WriteCSV(work2_csvd);
		if (iToDo == 2 && work2_nra->cRepeatType == 1)
		  WriteCSV(work2_csvd);
		if (iToDo == 3 && work2_nra->cRepeatType > 1)
		  WriteCSV(work2_csvd);
	  }
    }
  }
}
