#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "apptout.h"

extern short  iFileType;
extern short  iFileDefNum;
extern short  iHeader;
extern short  iEvent;
extern short  iAppt;
extern short  iToDo;

void PrintHeader(PFDC start_fdc)
{
  PFDC	work_fdc;
  PFDEF	curr_fd;
  char	szOut[BUF];
  short iCounter;

  memset(szOut, '\0', BUF);

  if (iHeader){
    if (iAppt && iFileType == 2){
	  for(work_fdc = start_fdc; work_fdc; work_fdc = work_fdc->pnext_fdc){
		curr_fd = work_fdc->pfd;
		switch(curr_fd->cFieldType){
		case 2:		/* Description or Location */
		case 7:		/* Time */
		case 19:	/* Date */
		case 23:	/* Date's */
		  PrintString(work_fdc->szName, szOut, TRUE);
		  break;
		case 10:	/* Note */
		  PrintString(work_fdc->szName, szOut, FALSE);
		  break;
		}
	  } /* End of for */
	}else if(iEvent && iFileType == 2){
	  for(work_fdc = start_fdc; work_fdc; work_fdc = work_fdc->pnext_fdc){
		curr_fd = work_fdc->pfd;
		switch(curr_fd->cFieldType){
		case 2:		/* Description or Location */
		case 19:	/* Date */
		case 23:	/* Date's */
		  PrintString(work_fdc->szName, szOut, TRUE);
		  break;
		case 10:	/* Note */
		  PrintString(work_fdc->szName, szOut, FALSE);
		  break;
		}
	  } /* End of for */
	}else if(iToDo && iFileType == 2){
	  for(work_fdc = start_fdc; work_fdc; work_fdc = work_fdc->pnext_fdc){
		curr_fd = work_fdc->pfd;
		switch(curr_fd->cFieldType){
		case 2:		/* Description */
		  if (strstr(work_fdc->szName, "Lo&cation")) break;
		case 8:		/* Complete Date */
		case 19:	/* Start Date */
		case 22:	/* Priority */
		case 23:	/* Due Date's */
		  PrintString(work_fdc->szName, szOut, TRUE);
		  break;
		case 10:	/* Note */
		  PrintString(work_fdc->szName, szOut, FALSE);
		  break;
		}
	  } /* End of for */
	}else{
	  iCounter = 1;
	  for(work_fdc = start_fdc; work_fdc; work_fdc = work_fdc->pnext_fdc){
		curr_fd = work_fdc->pfd;
		switch(curr_fd->cFieldType){
		case 0:
		case 1:
		case 2:		/* Description or Location */
		case 3:
		case 4:
		case 5:
		case 6:
		case 7:
		case 8:
		case 9:
		case 10:	/* Note */
		case 13:
		case 15:
		case 23:	/* Date's */
		  if (iCounter == iFileDefNum)
			PrintString(work_fdc->szName, szOut, FALSE);
		  else
			PrintString(work_fdc->szName, szOut, TRUE);
		  iCounter++;
		  break;
		}
	  } /* End of for */
	}
	fprintf(stdout, szOut);
  } /* End if */
}
