#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "apptout.h"

extern short  iCSV;
extern short  iTAB;

void PrintString(char * szWord, char *szOut, short nFlag)
{
  char	*szW;
  short i, j, iLength;

  iLength = strlen(szWord);

  if ((szW = (char *)malloc(iLength + 1)) == NULL){
    fprintf(stderr, "Not enough memory in PrintString.\n");
    exit(1);
  }

  if (iCSV == 2 || iTAB == 2)
    sprintf(szOut, "%s\"", szOut);

  for (i = 0, j = 0; i < iLength; i++){
	if (szWord[i] != '&' && szWord[i] != '#'){
	  szW[j] = szWord[i];
	  j++;
	}
  }

  szW[j] = '\0';

  sprintf(szOut, "%s%s", szOut, szW);

  if (iCSV == 2 || iTAB == 2)
    sprintf(szOut, "%s\"", szOut);

  if (nFlag)
	sprintf(szOut, "%s%c", szOut, (iCSV ? ',' : (iTAB ? '\t' : '\n')));
  else{
	sprintf(szOut, "%s%c", szOut, '\n');
	if (!iCSV)
	  sprintf(szOut, "%s%c", szOut, '\n');
  }

  free(szW);
}
