#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "apptout.h"

extern FILE *fpin;
extern short iAppt;
extern short iEvent;
extern short iToDo;
extern short iFileType;
extern short iAlarm;
extern long  lLineCounter;

void ReadCSV(PFDC start_fdc, PSCSV start_scsv, PSINF *pSeekInfo)
{
  char  szBuffer[BUF];
  short nKind;
  PCSVD curr_csvd;
  PNRA  curr_nra;
  PRIA  curr_ria;

  while(fgets(szBuffer, BUF, fpin)){

    lLineCounter++;

	if (iFileType == 2){

	  /* Ready NRA & CSVD & RIA*/
	  curr_csvd = MakeCSVD((char)(1));
	  curr_ria = curr_csvd->pria;
	  curr_nra = curr_csvd->pnra;

	  if (iAppt){
	    nKind = 128 + iAlarm;
/*		nKind = 135;	   Alarm=ON,  MonthView=ON,  WeekView=ON */
/*		nKind = 134;	   Alarm=OFF, MonthView=ON,  WeekView=ON */
/*		nKind = 133;	   Alarm=ON,  MonthView=OFF, WeekView=ON */
/*		nKind = 132;	   Alarm=OFF, MonthView=OFF, WeekView=ON */
/*		nKind = 131;	   Alarm=ON,  MonthView=ON,  WeekView=OFF */
/*		nKind = 130;	   Alarm=OFF, MonthView=ON,  WeekView=OFF */
/*		nKind = 129;	   Alarm=ON,  MonthView=OFF  WeekView=OFF */
/*		nKind = 128;	   Alarm=OFF, MonthView=OFF, WeekView=OFF */
		curr_csvd->cKind = 128;
	  }
	  if (iEvent){
		nKind = 38;		/* MonthView=ON, WeekView=ON */
		curr_csvd->cKind = 32;
	  }
	  if (iToDo){
		nKind = 20;		/* CarryForward=ON */
		curr_csvd->cKind = 16;
	  }

	  if (iToDo)
		CSVToNRAToDo(curr_csvd, szBuffer, nKind);
	  else
		CSVToNRAAppt(curr_csvd, szBuffer, nKind);

	  AddUserType14(start_scsv, curr_csvd, pSeekInfo);
	}else if(iFileType == 1){
	  WriteDB(start_fdc, pSeekInfo, szBuffer);
    }
  }
}
