#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "apptout.h"

extern FILE   *fp;
extern FILE *fpout;
extern FILE *fpin;
extern long   lFileLast;
extern short  iFileType;
extern short  iDebugG;
extern short  iDebugG2;
extern short  iHeader;
extern short  iEvent;
extern short  iSilent;
extern short  iAppt;
extern short  iToDo;
extern short  iOutAppt;
extern short  iNoteNum;
extern short  iAllRecNum;
extern long   lLookUpSeek;
extern short  iFileDefNum;
extern short  iNotePoint;
extern short  iOffsetLength;
extern char * szUserType14_0;

PFDC ReadField(PFDC start_fdc, PSINF *pSeekInfo)
{
  char			*szName;
  char			*szWork;
  char 			*szX;
  short			iSize;
  short         iCounter = 0;
  short			iGroupFlag = 0;
  RHDR			rh;
  PFDC			curr_fdc, work_fdc;
  PFDEF			curr_fd;
  unsigned char index[8];
  short i, iWork;
  short iPer, iPerMark = 0;

  if (iSilent < 2){
	fprintf(stderr, "       0%%"
		"|----+----+----+----+----|----+----+----+----+----|100%%\n");
	fprintf(stderr, " Pass-1  |");
  }

  while(1){

	/* Proccess print */
	if (iSilent < 2){
	  iPer = (short)((double)ftell(fp)/(double)lFileLast*100.);
	  if (iPer < 100){
		for (i=2;i<=iPer - iPerMark;i=i+2){
		  fprintf(stderr, "o");
		}
	  }
      if (i>2)
		iPerMark = iPerMark+(i-2);
	}

	/* End of file */
    if (feof(fp)){
	  if (iSilent < 2){
		if (iPerMark < 98)
		  fprintf(stderr, "o");
		fprintf(stderr, "|\n");
	  }
	  if (iFileType == 1) fprintf(stderr, "\n");
      break;
    }

	/* Read standard record header */
    if (fread_RHDR(&rh, 1, RHDR_SIZE, fp) != RHDR_SIZE){
	  if (iSilent < 2){
		if (iPerMark < 98)
		  fprintf(stderr, "o");
		fprintf(stderr, "|\n");
	  }
	  if (iFileType == 1) fprintf(stderr, "\n");
      break;
    }

    if(iDebugG){
      CheckRecordType(rh.cType);
      CheckRecordStatus(rh.cStatus);
      fprintf(stdout, "  Record Length : %d\n", rh.iLength);
      fprintf(stdout, "  Record Number : %d\n\n", rh.iRecord);
	  fprintf(stdout, "  Index Current : %ld\n\n", ftell(fp));
    }

    if (rh.cType == TYPE_LOOKUPTABLE){ /* End of DATA */
      if (iDebugG){
		for(i=0;i<iAllRecNum;i++){
		  if (fread(index, 8, 1, fp) != 1){
			fprintf(stderr, "TEST!! Failed read TYPE_DEFFIELD in file.\n");
			break;
		  }else{
			fprintf(stdout, "%d:Index 1 = %d index[0]=%x, index[1]=%x)\n", 
			  i, index[1]*256+index[0], index[0], index[1]);
			fprintf(stdout, "Index 2 = %d index[2]=%x, index[3]=%x\n", 
			  index[3]*256+index[2], index[2], index[3]);
			fprintf(stdout, "Index 3 = %x\n", index[4]);
			fprintf(stdout, "Index 4 = %ld\n\n", 
				index[7]*65536+index[6]*256+index[5]);
		  }
		}
		fprintf(stdout, "Index Current = %ld\n\n", ftell(fp));
		for(i=0;i<32;i++){
		  if (fread(&iWork, 2, 1, fp) != 1){
			fprintf(stderr, "TEST!! Failed read TYPE_DEFFIELD in file.\n");
			break;
		  }else{
			fprintf(stdout, "%d:iWork = %d\n\n", i, iWork);
		  }
		}
		fprintf(stdout, " Index Current = %ld\n\n", ftell(fp));
	  }
	  if (iSilent < 2){
		if (iPerMark < 98)
		  fprintf(stderr, "o");
		fprintf(stderr, "|\n");
	  }
	  if (iFileType == 1) fprintf(stderr, "\n");
      break;

	}else if(rh.cType == TYPE_DATA || rh.cType == TYPE_NOTE){

      fseek(fp, rh.iLength - 6, SEEK_CUR);

	}else if(rh.cType == TYPE_CATEGORY){

      iSize = rh.iLength - 6;
      if ((szWork = (char *)malloc(iSize + 1)) == NULL){
        fprintf(stderr, "1.Not enough memory in ReadField.\n");
        exit(1);
      }
      if (fread(szWork, 1, iSize, fp) != iSize){
        fprintf(stderr, "4. Failed read TYPE_DEFFIELD in file.\n");
        exit(1);
      }
      szWork[iSize]='\0';
	  if (iOutAppt){
		AddSeekInfo(pSeekInfo, &rh, ftell(fpout));
		fwrite_RHDR(&rh, RHDR_SIZE, 1, fpout);
		fwrite(szWork, iSize, 1, fpout);
	  }
/*	  fprintf(stdout, "szWork=%s\n", szWork);*/
/*      fseek(fp, rh.iLength - 6, SEEK_CUR); */
/***** Add 94.10.31 */
      free(szWork);
/***** Add 94.10.31 */

	}else if(rh.cType == 14 || rh.cType == 15){

      iSize = rh.iLength - 6;
      if ((szWork = (char *)malloc(iSize + 1)) == NULL){
        fprintf(stderr, "1.Not enough memory in ReadField.\n");
        exit(1);
      }
      if (fread(szWork, 1, iSize, fp) != iSize){
        fprintf(stderr, "4. Failed read TYPE_DEFFIELD in file.\n");
        exit(1);
      }
      szWork[iSize]='\0';
	  if (iDebugG){
		for (i=0;i<iSize;i++)
          fprintf(stdout, "TYPE_USER(%d):%d, %c, %x\n", 
            i, (unsigned char)szWork[i], szWork[i], szWork[i]);
		fprintf(stdout, "\n");
	  }
      if (rh.cType == 14){
        if (rh.iRecord == 0){
          szUserType14_0 = szWork;
        }else{
          free(szWork);
        }
      }else{
        if (iOutAppt){
	      AddSeekInfo(pSeekInfo, &rh, ftell(fpout));
          fwrite_RHDR(&rh, RHDR_SIZE, 1, fpout);
	      fwrite(szWork, iSize, 1, fpout);
	    }
        free(szWork);
      }

    }else if (rh.cType == TYPE_VIEWPTTABLE){ 

	  if (iDebugG2){
        if ((szX = (unsigned char *)malloc(rh.iLength - 5)) == NULL){
          fprintf(stderr, "2.Not enough memory in ReadField.\n");
          exit(1);
        }
        if (fread(szX, rh.iLength-6, 1, fp) != 1){
          fprintf(stderr, "3. Failed read TYPE_DEFFIELD in file.\n");
          exit(1);
        }
        for (i=0;i<(rh.iLength-6)/2;i++){
          fprintf(stdout, "rh.iLength=%d : i=%d\n", rh.iLength, i);
          fprintf(stdout, "VIEW : %c, %c\n", szX[2*i], szX[2*i+1]);
          fprintf(stdout, "VIEW : %d, %d\n", szX[2*i], szX[2*i+1]);
          fprintf(stdout, "VIEW : %x, %x\n", szX[2*i], szX[2*i+1]);
          fprintf(stdout, "VIEW : %d\n", szX[2*i+1]*256+szX[2*i]);
          fprintf(stdout, "VIEW : %d, %d, %d\n",
              szX[2*i+1] * 256 + szX[2*i], szX[2*i], szX[2*i+1]);
        }
        free(szX);
      }else{
        fseek(fp, rh.iLength - 6, SEEK_CUR);
      }

    }else if(rh.cType == TYPE_FIELDDEF){ /* Read field data */

      if ((curr_fdc = (PFDC)malloc(sizeof(FDC))) == NULL){
        fprintf(stderr, "3.Not enough memory in ReadField.\n");
        exit(1);
      }
      curr_fdc->pnext_fdc = (PFDC)NULL;

      if ((curr_fd = (PFDEF)malloc(sizeof(FDEF))) == NULL){
        fprintf(stderr, "4.Not enough memory in ReadField.\n");
        exit(1);
      }
      curr_fdc->pfd = curr_fd;

      if (fread_FDEF(curr_fd, FDEF_SIZE, 1, fp) != 1){
        fprintf(stderr, "2. Failed read TYPE_DEFFIELD in file.\n");
        exit(1);
      }

      iSize = rh.iLength - RHDR_SIZE - FDEF_SIZE;

	  switch(curr_fd->cFieldType){
	  case 0:
	  case 1:
	  case 2:
	  case 3:
	  case 4:
	  case 5:
	  case 6:
	  case 7:
	  case 10:
	  case 13:
	  case 15:
		iFileDefNum++;
		iOffsetLength = iOffsetLength + 2;
		iGroupFlag = 0;
		break;
	  case 8:
		iFileDefNum++;
		iOffsetLength = iOffsetLength + 3;
		iGroupFlag = 0;
		break;
	  case 11:
	    iGroupFlag = 1;
	    break;
	  case 9:	/* Option button */
		iFileDefNum++;
		if (iGroupFlag)
		  iOffsetLength = iOffsetLength + 2;
		iGroupFlag = 0;
		break;
	  }

      if ((szName = (char *)malloc(iSize + 1)) == NULL){
        fprintf(stderr, "5.Not enough memory in ReadField.\n");
        exit(1);
      }

      if (fread(szName, 1, iSize, fp) != iSize){
        fprintf(stderr, "3. Failed read TYPE_DEFFIELD in file.\n");
        exit(1);
      }

	  if (iOutAppt){
	    AddSeekInfo(pSeekInfo, &rh, ftell(fpout));
	    fwrite_RHDR(&rh, RHDR_SIZE, 1, fpout);
		fwrite_FDEF(curr_fd, FDEF_SIZE, 1, fpout);
		fwrite(szName, iSize, 1, fpout);
	  }

      szName[iSize] = '\0';

      curr_fdc->szName = szName;

      if (start_fdc == NULL){
        start_fdc = curr_fdc;
      }else {
        iCounter = 0;
        for(work_fdc=start_fdc;
            work_fdc;
            work_fdc=(work_fdc->pnext_fdc)){
          if ((work_fdc->pnext_fdc) == NULL) break;
        }
        (work_fdc->pnext_fdc) = curr_fdc;
      }
    }else{
      iSize = rh.iLength - 6;
      if ((szWork = (char *)malloc(iSize + 1)) == NULL){
        fprintf(stderr, "6.Not enough memory in ReadField.\n");
        exit(1);
      }
      if (fread(szWork, 1, iSize, fp) != iSize){
        fprintf(stderr, "4. Failed read TYPE_DEFFIELD in file.\n");
        exit(1);
      }
	  if (iOutAppt){
	    if(!(rh.cStatus & 0x01)){
		  AddSeekInfo(pSeekInfo, &rh, ftell(fpout));
	      fwrite_RHDR(&rh, RHDR_SIZE, 1, fpout);
		  fwrite(szWork, iSize, 1, fpout);
		}
	  }
	  free(szWork);
    }
  } /* End of while */

  /* Print header infomation */
  if (iFileType == 1)
    PrintHeader(start_fdc);
/*
fprintf(stdout, "iFileDefNum=%d\n", iFileDefNum);
*/
  return(start_fdc);
}
