#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "apptout.h"

extern FILE *fpout;
extern char * szUserType14_0;
extern short iAppt;
extern short iEvent;
extern short iToDo;
extern short iUserType14;
extern short iStartNum;

void WriteUserType14(PSCSV start_scsv, PSINF *pSeekInfo)
{
  unsigned char szData[5];
  RHDR	rh;
  PCSVD	start_csvd, other_csvd, next_csvd, work_csvd, work2_csvd;
  PNRA  work_nra, next_nra, other_nra, work2_nra;
  short iNum = 0;
  short iStartNum;
  
  start_csvd = start_scsv->start_csvd;
  other_csvd = start_scsv->other_csvd;
  if (other_csvd)
	iStartNum = other_csvd->iRecordNum;
  else
    iStartNum = -1;
  
  if (other_csvd){
    work_csvd = other_csvd;
    for(;work_csvd;work_csvd=next_csvd){
      work_nra = work_csvd->pnra;
      next_csvd = work_csvd->pnext_csvd;
      
      /* If chain end */
      if (next_csvd){
		next_nra = next_csvd->pnra;
		work_nra->iNextRecNum = next_csvd->iRecordNum;
		next_nra->iPrevRecNum = work_csvd->iRecordNum;
		WriteDATA(work_csvd, pSeekInfo);
      }else{
		WriteDATA(work_csvd, pSeekInfo);
		break;
      }
    }
  }
  
  for(work_csvd=start_csvd;work_csvd;work_csvd=work_csvd->pnext_csvd){
    work_nra = work_csvd->pnra;
    other_csvd = work_csvd->pdown_csvd;
    
    if (other_csvd) {
      other_nra = other_csvd->pnra;
      work_nra->iNextRecNum = other_csvd->iRecordNum;
      other_nra->iPrevRecNum = work_csvd->iRecordNum;
      WriteDATA(work_csvd, pSeekInfo);
      
      work2_csvd = other_csvd;
      for(;work2_csvd;work2_csvd=next_csvd){
		work2_nra = work2_csvd->pnra;
		next_csvd = work2_csvd->pnext_csvd;
		if (next_csvd){
		  next_nra = next_csvd->pnra;
		  work2_nra->iNextRecNum = next_csvd->iRecordNum;
		  next_nra->iPrevRecNum = work2_csvd->iRecordNum;
		  WriteDATA(work2_csvd, pSeekInfo);
		}else{
		  WriteDATA(work2_csvd, pSeekInfo);
		  break;
		}
      }
    }else{		/* if other_csvd is NULL */
      WriteDATA(work_csvd, pSeekInfo);
    }
  }
  
  iNum = iUserType14;
  
  rh.cType = 14;
  rh.cStatus = 0x02;
  rh.iLength = 23+6;
  rh.iRecord = 0;
  
  AddSeekInfo(pSeekInfo, &rh, ftell(fpout));
  fwrite_RHDR(&rh, RHDR_SIZE, 1, fpout);
  
  if(iStartNum < 0){
    szUserType14_0[17] = -1;
    szUserType14_0[18] = -1;
  }else{
    szUserType14_0[17] = iStartNum % 0x100;
    szUserType14_0[18] = iStartNum / 0x100;
  }
  
  szUserType14_0[19] = iNum % 0x100;
  szUserType14_0[20] = iNum / 0x100;
  fwrite(szUserType14_0, 23, 1, fpout);
  
  rh.cType = 14;
  rh.cStatus = 0x02;
  rh.iLength = iNum*5+5+6;
  rh.iRecord = 1;
  
  AddSeekInfo(pSeekInfo, &rh, ftell(fpout));
  fwrite_RHDR(&rh, RHDR_SIZE, 1, fpout);
  
  for(work_csvd=start_csvd;work_csvd;work_csvd=work_csvd->pnext_csvd){
    work_nra = work_csvd->pnra;
    szData[0] = work_nra->cYear;
    szData[1] = work_nra->cMonth; 
    szData[2] = work_nra->cDay;
    szData[3] = work_csvd->iFirstRecord % 0x100;
    szData[4] = work_csvd->iFirstRecord / 0x100;
    fwrite(szData, 5, 1, fpout);
  }
  szData[0] = 90;
  szData[1] = 0;
  szData[2] = 0;
  szData[3] = -1;
  szData[4] = -1;
  fwrite(szData, 5, 1, fpout);
}
