#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "apptout.h"

extern short iUserType14;
extern short iDataNum;

PCSVD AddChainForDay(PCSVD start_csvd, PCSVD curr_csvd, short iFlag)
{
  PCSVD work_csvd, prev_csvd;
  PNRA  curr_nra, work_nra;
  short iStartTimeWork;
  short iStartTimeCurr;
  
  curr_nra = curr_csvd->pnra;
  
  if (start_csvd == NULL){
    iDataNum++;
    if(!iFlag)
      iUserType14++;
    return(curr_csvd);
  }

  work_csvd = start_csvd;
  prev_csvd = start_csvd;
  for (;work_csvd;work_csvd=work_csvd->pnext_csvd){
    work_nra = work_csvd->pnra;

    if (work_nra->cYear == curr_nra->cYear){
      if (work_nra->cMonth == curr_nra->cMonth){
		if (work_nra->cDay == curr_nra->cDay){
		  if (curr_nra->iEndDate == 0 && curr_nra->cFlags >= 32){
			iStartTimeWork=
				work_nra->cStartTimePri2*256 + work_nra->cStartTimePri1;
			iStartTimeCurr=
				curr_nra->cStartTimePri2*256 + curr_nra->cStartTimePri1;
			if (iStartTimeWork < iStartTimeCurr)
			  work_csvd->pdown_csvd =
					AddChainForTime(work_csvd->pdown_csvd, curr_csvd);
			else{
			  curr_csvd->pdown_csvd = work_csvd;
			  curr_csvd->pnext_csvd = work_csvd->pnext_csvd;
			  work_csvd->pnext_csvd = work_csvd->pdown_csvd;
			  work_csvd->pdown_csvd = NULL;
			  if(prev_csvd == work_csvd)
				start_csvd = curr_csvd;
			  else
				prev_csvd->pnext_csvd = curr_csvd;
			}
		  }else
			break;
		  iDataNum++;
		  return(start_csvd);
		}else if(work_nra->cDay > curr_nra->cDay){
		  break;
		}
      }else if(work_nra->cMonth > curr_nra->cMonth){
		break;
      }
    }else if(work_nra->cYear > curr_nra->cYear){
      break;
    }
    prev_csvd = work_csvd;
  }

  if(work_csvd == NULL && prev_csvd != NULL){
    prev_csvd->pnext_csvd = curr_csvd;
  }else{
    if(prev_csvd == work_csvd)
      start_csvd = curr_csvd;
    else
      prev_csvd->pnext_csvd = curr_csvd;
    curr_csvd->pnext_csvd = work_csvd;
  }
  
  iDataNum++;
  if (!iFlag)
    iUserType14++;
  return(start_csvd);
}
