#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "apptout.h"

extern long lLineCounter;

char * GetCSV(char * pszData, short iNum, char cST)
{
  char  *szW;
  char  *pszW;
  short iCount;
  short iLength;
  short i, j;
  short iDQ = 0;

  if ((szW = (char *)malloc(BUF)) == NULL){
    fprintf(stderr, "1.Not enough memory in GetCSV.\n");
    exit(1);
  }

  iLength = strlen(pszData);

  if (!iLength){
    if ((pszW = (char *)malloc(1)) == NULL){
      fprintf(stderr, "2.Not enough memory in GetCSV.\n");
      exit(1);
    }
    pszW[0] = '\0';
    free(szW);
    return(pszW);
  }

  if (cST != '0'){

  iCount = 0;

  for(i = j = 0; i < iLength; i++){
/*	if (pszData[i] == '\"'){ */
	if (pszData[i] == cST){
	  iDQ = (iDQ + 1)%2;
	  if (iDQ) iCount++;
	  else{
	    if (pszData[i-1] == cST && iCount == iNum){
          if ((pszW = (char *)malloc(1)) == NULL){
            fprintf(stderr, "3. Not enough memory in GetCSV.\n");
            exit(1);
          }
          pszW[0] = '\0';
          free(szW);
          return(pszW);
	    }
	  }
	  continue;
    }else if(pszData[i] == '\0'){
      fprintf(stderr, "Check CSV file at %ld\n", lLineCounter);
      exit(1);
    }
	if (!iDQ) continue;
    if (iCount < iNum){
      continue;
    }else if (iCount > iNum){
      szW[j] = '\0';
      if ((pszW = (char *)malloc(strlen(szW) + 1)) == NULL){
        fprintf(stderr, "4. Not enough memory in GetCSV.\n");
        exit(1);
      }
      strcpy(pszW, szW);
      free(szW);
      return(pszW);
    }
    szW[j] = pszData[i];
    j++;
  }

  }else{

  iCount = 1;

  for(i = j = 0; i < iLength; i++){
	if (pszData[i] == ','){
	  iCount++;
	  continue;
    }else if(pszData[i] == '\0' || pszData[i] == '\n'){
      szW[j] = '\0';
      if ((pszW = (char *)malloc(strlen(szW) + 1)) == NULL){
        fprintf(stderr, "5. Not enough memory in GetCSV.\n");
        exit(1);
      }
      strcpy(pszW, szW);
      free(szW);
      return(pszW);
    }
    if (iCount < iNum){
      continue;
    }else if (iCount > iNum){
      szW[j] = '\0';
      if ((pszW = (char *)malloc(strlen(szW) + 1)) == NULL){
        fprintf(stderr, "6. Not enough memory in GetCSV.\n");
        exit(1);
      }
      strcpy(pszW, szW);
      free(szW);
      return(pszW);
    }
    szW[j] = pszData[i];
    j++;
  }

  }

  szW[j] = '\0';

  if ((pszW = (char *)malloc(strlen(szW) + 1)) == NULL){
    fprintf(stderr, "7. Not enough memory in GetCSV.\n");
    exit(1);
  }

  strcpy(pszW, szW);
  pszW[strlen(szW)]='\0';

  free(szW);

  return(pszW);
}
