#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "apptout.h"

PCSVD MakeCSVD(char cFlag)
{
/* If cFlag is TRUE, it's repeating. If not that, it's non-repeating. */
  PCSVD	curr_csvd;
  PNRA	curr_nra;
  PRIA	curr_ria;

  /* Ready NRA & CSVD */
  if ((curr_nra = (PNRA)malloc(sizeof(NRA))) == NULL){
    fprintf(stderr, "1. Not enough memory in MakeCSVD.\n");
    exit(1);
  }
  if ((curr_csvd = (PCSVD)malloc(sizeof(CSVD))) == NULL){
    fprintf(stderr, "2. Not enough memory in MakeCSVD.\n");
    exit(1);
  }
  memset(curr_nra, '\0', sizeof(NRA));
  memset(curr_csvd, '\0', sizeof(CSVD));
  curr_csvd->pnra = curr_nra;
  curr_csvd->pria = NULL;
  curr_csvd->pnext_csvd = NULL;
  curr_csvd->pdown_csvd = NULL;

  /* Ready RIA for repeating */
  if (cFlag){
	if ((curr_ria = (PRIA)malloc(sizeof(RIA))) == NULL){
      fprintf(stderr, "3. Not enough memory in MakeCSVD.\n");
      exit(1);
	}
	memset(curr_ria, '\0', sizeof(RIA));
	curr_csvd->pria = curr_ria;
  }
  return(curr_csvd);
}
