#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "apptout.h"

extern FILE   *fp;
extern long   lFirst;
extern short  iDebugG;
extern short  iDebugG2;
extern short  iCSV;
extern short  iETC;
extern short  iNote;

char * ReadNote(short word, char cRepeatType)
{
  long			lCurrent = ftell(fp);	/* Save current position in file */
  RHDR			rh;
  short			iSize, i, j;
  char			*pszNote;
  char			*szBuffer, *szW;;
	
  fseek(fp, lFirst, SEEK_SET);	/* Go back to first record */

  while(1){
  	/* Search for note record */
    if (fread_RHDR(&rh, 1, RHDR_SIZE, fp) != RHDR_SIZE){
      fprintf(stderr, "1. Failed read TYPE_NOTE in file.\n");
      exit(1);
    }

    if (rh.cType == TYPE_LOOKUPTABLE) /* End of DATA */
      break;
	if (rh.cType != TYPE_NOTE || rh.iRecord != word){
	  /* Not a note or not our note, skip */
	  fseek(fp, rh.iLength-6, SEEK_CUR);
	  continue;
	}

	/* read note */
    iSize = rh.iLength - RHDR_SIZE;  /* Data size */

    if ((szBuffer = (char *)malloc(iSize + 1)) == NULL){
      fprintf(stderr, "1. Not enough memory in ReadNote.\n");
      exit(1);
    }
    if ((pszNote = (char *)malloc(iSize + 1)) == NULL){
      fprintf(stderr, "2. Not enough memory in ReadNote.\n");
      exit(1);
    }

    if (fread(szBuffer, 1, iSize, fp) != iSize){
      fprintf(stderr, "2. Failed read TYPE_NOTE in file.\n");
      exit(1);
    }
    szBuffer[iSize] = '\0';
    szW = szBuffer;
/*
    if (iDebugG2){
      for(i=0;i<iSize;i++)
        fprintf(stdout, "%c\n", szBuffer[i]);
    }
*/
	pszNote[iSize] = '\0';

	if (iNote == 1){
	  for(i = 0; i<iSize; i++){
		if (szBuffer[i] == '\r' || szBuffer[i] == '\n')
		  pszNote[i] = ' ';
		else
		  pszNote[i] = szBuffer[i];
	  }
	}else if (iNote == 2){
	  for(i = 0; i<iSize; i++){
		if (szBuffer[i] == '\r')
		  pszNote[i] = '\\';
		else if (szBuffer[i] == '\n')
		  pszNote[i] = 'n';
		else
		  pszNote[i] = szBuffer[i];
	  }
	}else{
	  for(i = j = 0; i<iSize; i++, j++){
		if (szBuffer[i] == '\r')
		  j = j - 1;
		else
		  pszNote[j] = szBuffer[i];
	  }
	  pszNote[j] = '\0';
	}

	free(szW);
/*	free(pszNote);*/

	/* go back to where we were and return */
	fseek(fp, lCurrent, SEEK_SET);
	return(pszNote);
  }
  fseek(fp, lCurrent, SEEK_SET);
}

