#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "apptout.h"

char * ReadRepeatDay(short iDay)
{
  char * pszDay;
  char szW[50], szW2[50];
  unsigned char cWeek;
  unsigned char cDay;

  memset(szW, '\0', 50);
  memset(szW2, '\0', 50);

  if (iDay < 129){
	if ((pszDay = (char*)malloc(4)) == NULL){
	  fprintf(stderr, "1. Not enough memory in RdRpDay.\n");
	  exit(1);
	}
    sprintf(pszDay, "%d", iDay);
  }else{
    cDay = iDay % 256;
    if ((cDay & 129) == 129)
      strcat(szW, "MON");
    if((cDay & 130) == 130){
      if (strlen(szW))
        strcat(szW, ":");
      strcat(szW, "TUE");
    }
    if((cDay & 132) == 132){
      if (strlen(szW))
        strcat(szW, ":");
      strcat(szW, "WED");
    }
    if((cDay & 136) == 136){
      if (strlen(szW))
        strcat(szW, ":");
      strcat(szW, "THU");
    }
    if((cDay & 144) == 144){
      if (strlen(szW))
        strcat(szW, ":");
      strcat(szW, "FRI");
    }
    if((cDay & 160) == 160){
      if (strlen(szW))
        strcat(szW, ":");
      strcat(szW, "SAT");
    }
    if((cDay & 192) == 192){
      if (strlen(szW))
        strcat(szW, ":");
      strcat(szW, "SUN");
	}

    cWeek = (unsigned char)(iDay / 256);
    if (!cWeek)
	  sprintf(szW2, "%s", szW);
	else
	  sprintf(szW2, "%dth/%s", cWeek, szW);
	if ((pszDay = (char*)malloc(strlen(szW2))) == NULL){
	  fprintf(stderr, "2. Not enough memory in RdRpDay.\n");
	  exit(1);
	}
	strcpy(pszDay, szW2);
  }
  return(pszDay);
}
